> For the complete documentation index, see [llms.txt](https://docs-v4.venus.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs-v4.venus.io/technical-reference/reference-governance/irm-risk-steward.md).

# IRMRiskSteward

## IRMRiskSteward

Contract that can update interest rate models updates received from RiskStewardReceiver.

## Solidity API

#### INTEREST\_RATE\_MODEL

The update type for interest rate model

```solidity
string INTEREST_RATE_MODEL
```

***

#### INTEREST\_RATE\_MODEL\_KEY

The update type key for interest rate model (keccak256 hash of INTEREST\_RATE\_MODEL)

```solidity
bytes32 INTEREST_RATE_MODEL_KEY
```

***

#### CORE\_POOL\_COMPTROLLER

Address of the BNB Core Pool Comptroller.

```solidity
contract ICorePoolComptroller CORE_POOL_COMPTROLLER
```

***

#### RISK\_STEWARD\_RECEIVER

Address of the RiskStewardReceiver used to validate incoming updates

```solidity
contract IRiskStewardReceiver RISK_STEWARD_RECEIVER
```

***

#### constructor

Sets the immutable CORE\_POOL\_COMPTROLLER and RISK\_STEWARD\_RECEIVER addresses and disables initializers

```solidity
constructor(address corePoolComptroller_, address riskStewardReceiver_) public
```

**Parameters**

| Name                  | Type    | Description                              |
| --------------------- | ------- | ---------------------------------------- |
| corePoolComptroller\_ | address | The address of the Core Pool Comptroller |
| riskStewardReceiver\_ | address | The address of the RiskStewardReceiver   |

**❌ Errors**

* Throws ZeroAddressNotAllowed if any of the addresses are zero

***

#### initialize

Initializes the contract as ownable and access controlled.

```solidity
function initialize(address accessControlManager_) external
```

**Parameters**

| Name                   | Type    | Description                               |
| ---------------------- | ------- | ----------------------------------------- |
| accessControlManager\_ | address | The address of the access control manager |

***

#### applyUpdate

Applies an interest rate model update from the RiskStewardReceiver. Directly updates the market interest rate model on the vToken.

```solidity
function applyUpdate(struct RiskParameterUpdate update) external
```

**Parameters**

| Name   | Type                       | Description                         |
| ------ | -------------------------- | ----------------------------------- |
| update | struct RiskParameterUpdate | RiskParameterUpdate update to apply |

**📅 Events**

* Emits InterestRateModelUpdated with the updateId, market and new IRM address

**⛔️ Access Requirements**

* Only callable by the RiskStewardReceiver

**❌ Errors**

* Throws OnlyRiskStewardReceiver if the sender is not the RiskStewardReceiver
* Throws UnsupportedUpdateType if the update type is not supported

***

#### isSafeForDirectExecution

Checks if an update is safe for direct execution (no timelock required)

```solidity
function isSafeForDirectExecution(struct RiskParameterUpdate update) external view returns (bool)
```

**Parameters**

| Name   | Type                       | Description         |
| ------ | -------------------------- | ------------------- |
| update | struct RiskParameterUpdate | The update to check |

**Return Values**

| Name | Type | Description                                                                |
| ---- | ---- | -------------------------------------------------------------------------- |
| \[0] | bool | True if update is safe for direct execution, false if timelock is required |

**❌ Errors**

* Throws UnsupportedUpdateType if the update type is not supported
* Throws RedundantValue if the new IRM address is equal to the current IRM address

***


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs-v4.venus.io/technical-reference/reference-governance/irm-risk-steward.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
